ContextualDeserializer
Date: 2016-12-04

com.fasterxml.jackson.databind.deser

## Interface ContextualDeserializer

- All Known Implementing Classes:
    ArrayBlockingQueueDeserializer, AtomicReferenceDeserializer, BeanAsArrayBuilderDeserializer, BeanAsArrayDeserializer, BeanDeserializer, BeanDeserializerBase, BuilderBasedDeserializer, CollectionDeserializer, DateDeserializers.CalendarDeserializer, DateDeserializers.DateBasedDeserializer, DateDeserializers.DateDeserializer, DateDeserializers.SqlDateDeserializer, DateDeserializers.TimestampDeserializer, DelegatingDeserializer, EnumMapDeserializer, EnumSetDeserializer, MapDeserializer, MapEntryDeserializer, ObjectArrayDeserializer, PrimitiveArrayDeserializers, ReferenceTypeDeserializer, StdDelegatingDeserializer, StringArrayDeserializer, StringCollectionDeserializer, ThrowableDeserializer, UntypedObjectDeserializer

      public interface ContextualDeserializer

  Add-on interface that `JsonDeserializer`s can implement to get a callback that can be used to create contextual (context-dependent) instances of deserializer to use for handling properties of supported type. This can be useful for deserializers that can be configured by annotations, or should otherwise have differing behavior depending on what kind of property is being deserialized.

  Note that in cases where deserializer needs both contextualization and resolution -- that is, implements both this interface and `ResolvableDeserializer` -- resolution via `ResolvableDeserializer` occurs first, and contextual resolution (via this interface) later on.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.

- - ### Method Detail

    - #### createContextual

          JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                             BeanProperty property)
                                               throws JsonMappingException

      Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`